package cn.com.qmth.examcloud.support.test;

import cn.com.qmth.examcloud.commons.util.FileUtil;
import cn.com.qmth.examcloud.commons.util.JsonMapper;
import cn.com.qmth.examcloud.support.fss.FssFactory;
import cn.com.qmth.examcloud.support.fss.FssHelper;
import cn.com.qmth.examcloud.support.fss.FssProperty;
import cn.com.qmth.examcloud.support.fss.FssService;
import cn.com.qmth.examcloud.support.fss.model.FssFileInfo;
import cn.com.qmth.examcloud.support.fss.model.FssType;
import org.apache.commons.io.IOUtils;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.core.config.Configurator;
import org.junit.Before;
import org.junit.Test;

import java.io.File;
import java.nio.file.Files;

public class OssClientTest {

    @Before
    public void init() {
        Configurator.setRootLevel(Level.INFO);
    }

    @Test
    public void demoTest() throws Exception {
        FssProperty.FSS_TYPE = FssType.ALIYUN_OSS;
        FssProperty.FSS_BUCKET = "examcloud-test";
        FssProperty.FSS_REGION_ID = "oss-cn-shenzhen";
        FssProperty.FSS_ENDPOINT = "https://oss-cn-shenzhen.aliyuncs.com";
        FssProperty.FSS_INTERNAL_ENDPOINT = "https://oss-cn-shenzhen-internal.aliyuncs.com";
        FssProperty.FSS_ACCESS_KEY_ID = "LTAI4FboXLCJzrjVo5dUoXaU";
        FssProperty.FSS_ACCESS_KEY_SECRET = "xxx";
        // FssProperty.FSS_URL_PREFIX = "https://examcloud-test.oss-cn-shenzhen.aliyuncs.com";
        FssProperty.FSS_URL_PREFIX = "https://ecs-test-static.qmth.com.cn";

        // FssProperty.FSS_TYPE = FssType.TENCENT_COS;
        // FssProperty.FSS_BUCKET = "examcloud-1252178304";
        // FssProperty.FSS_REGION_ID = "ap-guangzhou";
        // FssProperty.FSS_ENDPOINT = "https://cos.ap-guangzhou.myqcloud.com";
        // FssProperty.FSS_INTERNAL_ENDPOINT = "https://cos.ap-guangzhou.myqcloud.com";
        // FssProperty.FSS_ACCESS_KEY_ID = "AKID51lO89AEFNRNA90jGZiw9E5kCQh7djpn";
        // FssProperty.FSS_ACCESS_KEY_SECRET = "xxx";
        // FssProperty.FSS_URL_PREFIX = "https://examcloud-1252178304.cos.ap-guangzhou.myqcloud.com";

        final String testDir = "D:/home/test";
        File testFile = new File(testDir + "/abc.png");

        final String filePath = "/test/abc.png";
        final String fileMd5 = "80bf42bd4d12b2a38eff3b32249b17fd";

        FssService fssService = FssFactory.getInstance(false);
        System.out.println(new JsonMapper().toJson(fssService.buildSign(filePath)));

        // FssFileInfo result = fssService.writeFile(filePath, testFile, fileMd5);
        byte[] testBytes = IOUtils.toByteArray(Files.newInputStream(testFile.toPath()));
        FssFileInfo result = fssService.writeFile(filePath, testBytes, fileMd5);
        System.out.println(result.getFileUrl());

        File toFile = new File(testDir + "/abc-new.png");
        // fssService.readFile(filePath, toFile);
        byte[] bytes = fssService.readFile(filePath);
        FileUtil.saveToFile(bytes, toFile);

        System.out.println("exist:" + fssService.existFile(filePath));
        fssService.refreshFile(result.getFileUrl());

        // fssService.deleteFile(filePath);
    }

    // @Test
    public void demoTest2() throws Exception {
        FssProperty.FSS_URL_PREFIX = "https://ecs-test-static.qmth.com.cn";

        System.out.println(FssHelper.finalFileUrl("upyun-1://abc/123.jpg"));
        System.out.println(FssHelper.finalFileUrl("aliyun-1://abc/123.jpg"));
        System.out.println(FssHelper.finalFileUrl("aliyun-2://abc/123.jpg"));
        System.out.println(FssHelper.finalFileUrl("https://xxx.xxx/abc/123.jpg"));
        System.out.println(FssHelper.finalFileUrl("http://127.0.0.1:8080/abc/123.jpg"));
        System.out.println(FssHelper.finalFileUrl("/abc/123.jpg"));
        System.out.println(FssHelper.finalFileUrl("abc/123.jpg"));

        System.out.println(FssHelper.fixFilePath("upyun-1://abc/123.jpg"));
        System.out.println(FssHelper.fixFilePath("aliyun-1://abc/123.jpg"));
        System.out.println(FssHelper.fixFilePath("aliyun-2://abc/123.jpg"));
        System.out.println(FssHelper.fixFilePath("https://xxx.xxx/abc/123.jpg"));
        System.out.println(FssHelper.fixFilePath("http://127.0.0.1:8080/abc/123.jpg"));
        System.out.println(FssHelper.fixFilePath("/abc/123.jpg"));
        System.out.println(FssHelper.fixFilePath("abc/123.jpg"));
    }

}
